/*
 * PHY.h
 *
 *  Created on: Jan 29, 2016
 *      Author: badenhopcw
 */

#ifndef PHY_H_
#define PHY_H_
#include <stdlib.h>
#include <stdint.h>

namespace Zwave {

class PHY {
public:

	typedef uint8_t Datarate;
	typedef uint8_t Channel;
	typedef uint8_t Configuration;

	static const Datarate DATARATE_R1_9600Kbps = 0x01;
	static const Datarate DATARATE_R2_40000Kbps = 0x02;
	static const Datarate DATARATE_R3 = 0x03;

	static const Channel CHANNEL_A = 0x01;
	static const Channel CHANNEL_B = 0x02;
	static const Channel CHANNEL_C = 0x03;

	static const Configuration CONFIG_C1 = 0x01;
	static const Configuration CONFIG_C2 = 0x02;
	static const Configuration CONFIG_C3 = 0x03;

	//enum class Datarate { R1_9600Kbps, R2_40000Kbps, R3 };
	//enum class Channel { A, B, C };
	//enum class Configuration {C1, C2, C3};

	struct ConfigurationInstance{
		Configuration config;
		Datarate datarate;
		Channel channel;
	};

	static const size_t NUMBER_CONFIGURATIONS = 8;
	static const struct ConfigurationInstance CONFIGURATIONS[PHY::NUMBER_CONFIGURATIONS];

/*	enum class ConfigurationIndex {
			CFG1_CHANB_RATE2 = 0,
			CFG1_CHANB_RATE1 = 1,
			CFG2_CHANA_RATE3 = 2,
			CFG2_CHANB_RATE2 = 3,
			CFG2_CHANB_RATE1 = 4,
			CFG3_CHANA_RATE3 = 5,
			CFG3_CHANB_RATE3 = 6,
			CFG3_CHANC_RATE3 = 7
	};
*/

	typedef uint8_t ConfigIndex;
	static const ConfigIndex CFG1_CHANB_RATE2 = 0x00;
	static const ConfigIndex CFG1_CHANB_RATE1 = 0x01;
	static const ConfigIndex CFG2_CHANA_RATE3 = 0x02;
	static const ConfigIndex CFG2_CHANB_RATE2 = 0x03;
	static const ConfigIndex CFG2_CHANB_RATE1 = 0x04;
	static const ConfigIndex CFG3_CHANA_RATE3 = 0x05;
	static const ConfigIndex CFG3_CHANB_RATE3 = 0x06;
	static const ConfigIndex CFG3_CHANC_RATE3 = 0x07;

	PHY();
	virtual ~PHY();
};

} /* namespace Zwave */
#endif /* PHY_H_ */
