/*
 * PhyIface.h
 *
 *  Created on: Feb 1, 2016
 *      Author: badenhopcw
 */

#ifndef PHYIFACE_H_
#define PHYIFACE_H_

#include <stdlib.h>
#include <stdint.h>
#include "Timer.h"

namespace Zwave {

class PhyIface {
public:
	static const ssize_t RECVFRAME_TIMEOUT = -1;

	PhyIface();
	PhyIface (size_t config_index);
	virtual ~PhyIface() = 0;
	virtual void SendFrame (const uint8_t *frame, const size_t len, size_t numBeams, uint8_t beamTarget) = 0;
	virtual ssize_t RecvFrame (uint8_t *buf, const size_t maxlen, Timer *timer) = 0;

protected:
	size_t m_configIndex;
};

} /* namespace Zwave */
#endif /* PHYIFACE_H_ */
