/*
 * ScapyRadioIface.h
 *
 *  Created on: Jan 29, 2016
 *      Author: badenhopcw
 */

#ifndef SCAPYRADIOIFACE_H_
#define SCAPYRADIOIFACE_H_

#include "UdpSocketIface.h"
#include "PhyIface.h"
#include "Timer.h"
#include "MAC.h"
#include <sys/types.h>

namespace Zwave {

class ScapyRadioIface : public PhyIface{
public:
	static const size_t HEADER_LENGTH = 8;
	static const size_t MAGIC_NUMBER = 1;
	static const uint8_t HDR[HEADER_LENGTH];

	ScapyRadioIface ();
	ScapyRadioIface (std::string TXipAddress, uint16_t TXudpPort, std::string RXipAddress, uint16_t RXudpPort);
	virtual ~ScapyRadioIface();

	void SendFrame (const uint8_t *frame, const size_t len, size_t numBeams, uint8_t beamTarget);
	ssize_t RecvFrame (uint8_t *buf, const size_t maxlen, Timer *timer);


protected:
	static const size_t BUFFER_SIZE = MAC::MAX_MPDU_SIZE + HEADER_LENGTH; //CWB: PHY layer should determine max frame length and MAC inherits it right?
	uint8_t m_buf[BUFFER_SIZE];
	UdpSocketClientIface m_udpClient;
	UdpSocketServerIface m_udpServer;
	fd_set m_selectFDs;
	int m_nfds;
};

} /* namespace Zwave */
#endif /* SCAPYRADIOIFACE_H_ */
