#ifndef _TIMER_H_
#define _TIMER_H_

#include <sys/time.h>
#include <stdint.h>
#include <string>

namespace Zwave{

class Timer{
public:
	static const uint32_t USEC_IN_SEC = 1000000;
	Timer ();
	Timer (struct timeval *delay);
	Timer (long sec, long usec);	
	virtual ~Timer ();

//	void SetAsDeadline (struct timeval *deadline);
	void SetAsDelay (struct timeval *delay);
	bool HasTimeExpired ();
	void GetRemainingTime (struct timeval &timeLeft);
	void GetDeadline (struct timeval &deadline);
	void PrintTimeVal(std::string header, struct timeval *tv);
private:
	//void add (struct timeval &result, struct timeval *a, struct timeval *b);
	//void sub (struct timeval &result, struct timeval *a, struct timeval *b); 
	struct timeval m_deadline;
};
}
#endif
