/*
 * ScapyIface.h
 *
 *  Created on: Feb 1, 2016
 *      Author: badenhopcw
 */

#ifndef UDP_SOCKET_IFACE_H_
#define UDP_SOCKET_IFACE_H_
#include <string>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdint.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <unistd.h>

namespace Zwave {
 
class UdpSocketClientIface {
public:
	UdpSocketClientIface (std::string IpAddress, uint16_t port, int flags);
	UdpSocketClientIface ();
	virtual ~UdpSocketClientIface();

	ssize_t SendTo (const uint8_t *buf, size_t len);
	int GetFlags ();
	void SetFlags (int f);
	int GetSocket ();

protected:
	int m_socket;
	int m_flags;
	::sockaddr_in m_sockAddr;
	::socklen_t m_sockLen;

};

class UdpSocketServerIface {
public:
	UdpSocketServerIface (std::string IpAddress, uint16_t port, int flags);
	UdpSocketServerIface ();
	virtual ~UdpSocketServerIface();

	ssize_t RecvFrom (uint8_t *buf, size_t len);
	int GetFlags ();
	void SetFlags (int f);
	int GetSocket ();

protected:
	int m_socket;
	int m_flags;
	::sockaddr_in m_sockAddr;
	::socklen_t m_sockLen;

};

} /* namespace Zwave */
#endif /* SCAPYIFACE_H_ */
